/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.ergebnis.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="D_HONDT_QUOTIENT.Ergebnis",
     query="SELECT o FROM DHondtQuotient o WHERE o.ergebnis=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "D_HONDT_QUOTIENT")
// @javax.persistence.IdClass(DHondtQuotientPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable
@javax.persistence.Inheritance(strategy = javax.persistence.InheritanceType.JOINED)
@javax.persistence.DiscriminatorColumn(name = "DISCRIMINATOR")
@javax.persistence.DiscriminatorValue(DHondtQuotient.DISCRIMINATOR_VALUE)

public
 class DHondtQuotient
extends AbstractDHondtQuotient
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "D_HONDT_QUOTIENT";

  /**
   * default constructor
   */
  public DHondtQuotient() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public DHondtQuotient(DHondtQuotient original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "d_hondt_quotient_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "DHondtQuotient")
    @javax.persistence.TableGenerator(name = "DHondtQuotient", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "DHondtQuotient", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient DHondtQuotientPK pkCache;

  @Override
  public DHondtQuotientPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new DHondtQuotientPK(getId());
    }

    return pkCache;
  }

  public static <E extends DHondtQuotient> java.util.Map<DHondtQuotientPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<DHondtQuotientPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends DHondtQuotient> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedDiscriminator = false;
          hasChangedNenner = false;
          hasChangedRang = false;
          hasChangedSitzgewinn = false;
          hasChangedTeilnehmerAmLosverfahren = false;
          hasChangedZaehler = false;
  
      hasChangedErgebnis = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "DISCRIMINATOR", nullable = DHondtQuotientConstants.DISCRIMINATOR_NULLABLE, length=DHondtQuotientConstants.DISCRIMINATOR_MAX_LENGTH)
        
  protected java.lang.String discriminator =  getInitialDiscriminator() ;

  @javax.persistence.Transient
  protected boolean hasChangedDiscriminator = false;

  public boolean hasChangedDiscriminator(){
    return hasChangedDiscriminator;
  }
  
  /**
   * Discriminator column for generalization
   *
   * getter for D_HONDT_QUOTIENT.DISCRIMINATOR
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getDiscriminator() {
        return discriminator;
      }

  /**
   * Discriminator column for generalization
   *
   * setter for D_HONDT_QUOTIENT.DISCRIMINATOR
   *
   * @param discriminator
   */
  @Override   public void setDiscriminator(@javax.annotation.Nullable  java.lang.String discriminator) {

       resetTkCache();
                  
                          java.lang.String discriminatorInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(discriminator, DHondtQuotientConstants.DISCRIMINATOR_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.discriminator
      , discriminatorInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDiscriminator |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("discriminator");
      }


      

       this.discriminator = discriminatorInternal;

         }

        
      @javax.persistence.Column(name = "NENNER", nullable = DHondtQuotientConstants.NENNER_NULLABLE, precision=DHondtQuotientConstants.NENNER_PRECISION, scale=DHondtQuotientConstants.NENNER_SCALE)
            
  protected java.lang.Long nenner =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNenner = false;

  public boolean hasChangedNenner(){
    return hasChangedNenner;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNenner = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenNenner;
  
  /**
   * 
   *
   * getter for D_HONDT_QUOTIENT.NENNER
   */
    @Override   public  java.lang.Long getNenner() {
        return nenner;
      }

  /**
   * 
   *
   * setter for D_HONDT_QUOTIENT.NENNER
   *
   * @param nenner
   */
  @Override   public void setNenner( java.lang.Long nenner) {

       resetTkCache();
                  java.lang.Long nennerInternal = nenner;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nenner
      , nennerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNenner |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nenner");
      }


             if (!isSeitLadenVeraendertNenner) {
          isSeitLadenVeraendertNenner = thisAttributChanged;
         if (isSeitLadenVeraendertNenner){
           wertNachLadenNenner=this.nenner;
         }
       }
      

       this.nenner = nennerInternal;

         }

        
      @javax.persistence.Column(name = "RANG", nullable = DHondtQuotientConstants.RANG_NULLABLE, precision=DHondtQuotientConstants.RANG_PRECISION, scale=DHondtQuotientConstants.RANG_SCALE)
            
  protected java.lang.Long rang =  null;

  @javax.persistence.Transient
  protected boolean hasChangedRang = false;

  public boolean hasChangedRang(){
    return hasChangedRang;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertRang = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenRang;
  
  /**
   * 
   *
   * getter for D_HONDT_QUOTIENT.RANG
   */
    @Override   public  java.lang.Long getRang() {
        return rang;
      }

  /**
   * 
   *
   * setter for D_HONDT_QUOTIENT.RANG
   *
   * @param rang
   */
  @Override   public void setRang( java.lang.Long rang) {

       resetTkCache();
                  java.lang.Long rangInternal = rang;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.rang
      , rangInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedRang |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("rang");
      }


             if (!isSeitLadenVeraendertRang) {
          isSeitLadenVeraendertRang = thisAttributChanged;
         if (isSeitLadenVeraendertRang){
           wertNachLadenRang=this.rang;
         }
       }
      

       this.rang = rangInternal;

         }

        
      @javax.persistence.Column(name = "SITZGEWINN", nullable = DHondtQuotientConstants.SITZGEWINN_NULLABLE)
    
  protected java.lang.Boolean sitzgewinn =  null;

  @javax.persistence.Transient
  protected boolean hasChangedSitzgewinn = false;

  public boolean hasChangedSitzgewinn(){
    return hasChangedSitzgewinn;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSitzgewinn = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenSitzgewinn;
  
  /**
   * 
   *
   * getter for D_HONDT_QUOTIENT.SITZGEWINN
   */
    @Override   public  java.lang.Boolean getSitzgewinn() {
        return sitzgewinn;
      }

  /**
   * 
   *
   * setter for D_HONDT_QUOTIENT.SITZGEWINN
   *
   * @param sitzgewinn
   */
  @Override   public void setSitzgewinn( java.lang.Boolean sitzgewinn) {

       resetTkCache();
                  java.lang.Boolean sitzgewinnInternal = sitzgewinn;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.sitzgewinn
      , sitzgewinnInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSitzgewinn |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("sitzgewinn");
      }


             if (!isSeitLadenVeraendertSitzgewinn) {
          isSeitLadenVeraendertSitzgewinn = thisAttributChanged;
         if (isSeitLadenVeraendertSitzgewinn){
           wertNachLadenSitzgewinn=this.sitzgewinn;
         }
       }
      

       this.sitzgewinn = sitzgewinnInternal;

         }

        
      @javax.persistence.Column(name = "TEILNEHMER_AM_LOSVERFAHREN", nullable = DHondtQuotientConstants.TEILNEHMER_AM_LOSVERFAHREN_NULLABLE)
    
  protected java.lang.Boolean teilnehmerAmLosverfahren =  null;

  @javax.persistence.Transient
  protected boolean hasChangedTeilnehmerAmLosverfahren = false;

  public boolean hasChangedTeilnehmerAmLosverfahren(){
    return hasChangedTeilnehmerAmLosverfahren;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertTeilnehmerAmLosverfahren = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenTeilnehmerAmLosverfahren;
  
  /**
   * 
   *
   * getter for D_HONDT_QUOTIENT.TEILNEHMER_AM_LOSVERFAHREN
   */
    @Override   public  java.lang.Boolean getTeilnehmerAmLosverfahren() {
        return teilnehmerAmLosverfahren;
      }

  /**
   * 
   *
   * setter for D_HONDT_QUOTIENT.TEILNEHMER_AM_LOSVERFAHREN
   *
   * @param teilnehmerAmLosverfahren
   */
  @Override   public void setTeilnehmerAmLosverfahren( java.lang.Boolean teilnehmerAmLosverfahren) {

       resetTkCache();
                  java.lang.Boolean teilnehmerAmLosverfahrenInternal = teilnehmerAmLosverfahren;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.teilnehmerAmLosverfahren
      , teilnehmerAmLosverfahrenInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTeilnehmerAmLosverfahren |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("teilnehmerAmLosverfahren");
      }


             if (!isSeitLadenVeraendertTeilnehmerAmLosverfahren) {
          isSeitLadenVeraendertTeilnehmerAmLosverfahren = thisAttributChanged;
         if (isSeitLadenVeraendertTeilnehmerAmLosverfahren){
           wertNachLadenTeilnehmerAmLosverfahren=this.teilnehmerAmLosverfahren;
         }
       }
      

       this.teilnehmerAmLosverfahren = teilnehmerAmLosverfahrenInternal;

         }

        
      @javax.persistence.Column(name = "ZAEHLER", nullable = DHondtQuotientConstants.ZAEHLER_NULLABLE, precision=DHondtQuotientConstants.ZAEHLER_PRECISION, scale=DHondtQuotientConstants.ZAEHLER_SCALE)
            
  protected java.lang.Long zaehler =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZaehler = false;

  public boolean hasChangedZaehler(){
    return hasChangedZaehler;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZaehler = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenZaehler;
  
  /**
   * 
   *
   * getter for D_HONDT_QUOTIENT.ZAEHLER
   */
    @Override   public  java.lang.Long getZaehler() {
        return zaehler;
      }

  /**
   * 
   *
   * setter for D_HONDT_QUOTIENT.ZAEHLER
   *
   * @param zaehler
   */
  @Override   public void setZaehler( java.lang.Long zaehler) {

       resetTkCache();
                  java.lang.Long zaehlerInternal = zaehler;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zaehler
      , zaehlerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZaehler |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zaehler");
      }


             if (!isSeitLadenVeraendertZaehler) {
          isSeitLadenVeraendertZaehler = thisAttributChanged;
         if (isSeitLadenVeraendertZaehler){
           wertNachLadenZaehler=this.zaehler;
         }
       }
      

       this.zaehler = zaehlerInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Ergebnis
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNIS_ID", referencedColumnName="ERGEBNIS_ID"))
  protected de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis;

  /**
   * 
   */
  @Override
  public void setErgebnis( de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnis
    , ergebnis);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebnis |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebnis");
    }

    this.ergebnis = ergebnis;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.ergebnis.entity.Ergebnis getErgebnis(){
    return this.ergebnis;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebnis = false;

  public boolean hasChangedErgebnis(){
    return hasChangedErgebnis;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("DHondtQuotient:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(DHondtQuotient other){
                                               other.nenner = this.nenner;
                                other.rang = this.rang;
                                other.sitzgewinn = this.sitzgewinn;
                                other.teilnehmerAmLosverfahren = this.teilnehmerAmLosverfahren;
                                other.zaehler = this.zaehler;
           
  other.setErgebnis(this.getErgebnis());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(DHondtQuotient.class)){
        copyEntityAttributesUsingSetter((DHondtQuotient) other.castTo(DHondtQuotient.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von DHondtQuotient: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(DHondtQuotient other){
                           other.setNenner(this.nenner);
                  other.setRang(this.rang);
                  other.setSitzgewinn(this.sitzgewinn);
                  other.setTeilnehmerAmLosverfahren(this.teilnehmerAmLosverfahren);
                  other.setZaehler(this.zaehler);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(DHondtQuotient other){
                                        if (hasChangedNenner) {
        other.setNenner(this.nenner);
      }
                             if (hasChangedRang) {
        other.setRang(this.rang);
      }
                             if (hasChangedSitzgewinn) {
        other.setSitzgewinn(this.sitzgewinn);
      }
                             if (hasChangedTeilnehmerAmLosverfahren) {
        other.setTeilnehmerAmLosverfahren(this.teilnehmerAmLosverfahren);
      }
                             if (hasChangedZaehler) {
        other.setZaehler(this.zaehler);
      }
             }





    @javax.persistence.Transient
    private transient DHondtQuotientTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public DHondtQuotientTK getDHondtQuotientTK(){
    if (tkCache==null) {
    tkCache = new DHondtQuotientTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getDHondtQuotientTK();
    }

  @Override
  public DHondtQuotientUK getUk(){
    return getDHondtQuotientUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return DHondtQuotient.class;
  }

public DHondtQuotientUK getDHondtQuotientUK(){

   return  new DHondtQuotientUK(



  );
}

  @javax.persistence.Transient
  private transient DHondtQuotientProperties properties;

  public DHondtQuotientProperties getProperties(){
    if (properties == null) {
      properties = new DHondtQuotientProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public DHondtQuotientProperties getDHondtQuotientProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return DHondtQuotientConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
             
      if (werteVorher.containsKey(DHondtQuotientConstants.MESSAGE_KEY_NENNER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DHondtQuotientConstants.MESSAGE_KEY_NENNER_EINZAHL);

        nenner =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(DHondtQuotientConstants.MESSAGE_KEY_RANG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DHondtQuotientConstants.MESSAGE_KEY_RANG_EINZAHL);

        rang =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(DHondtQuotientConstants.MESSAGE_KEY_SITZGEWINN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DHondtQuotientConstants.MESSAGE_KEY_SITZGEWINN_EINZAHL);

        sitzgewinn =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(DHondtQuotientConstants.MESSAGE_KEY_TEILNEHMER_AM_LOSVERFAHREN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DHondtQuotientConstants.MESSAGE_KEY_TEILNEHMER_AM_LOSVERFAHREN_EINZAHL);

        teilnehmerAmLosverfahren =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(DHondtQuotientConstants.MESSAGE_KEY_ZAEHLER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(DHondtQuotientConstants.MESSAGE_KEY_ZAEHLER_EINZAHL);

        zaehler =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                            if (isSeitLadenVeraendertNenner) {
      result.put(DHondtQuotientConstants.MESSAGE_KEY_NENNER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenNenner , nenner));
    }
                            if (isSeitLadenVeraendertRang) {
      result.put(DHondtQuotientConstants.MESSAGE_KEY_RANG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenRang , rang));
    }
                            if (isSeitLadenVeraendertSitzgewinn) {
      result.put(DHondtQuotientConstants.MESSAGE_KEY_SITZGEWINN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenSitzgewinn , sitzgewinn));
    }
                            if (isSeitLadenVeraendertTeilnehmerAmLosverfahren) {
      result.put(DHondtQuotientConstants.MESSAGE_KEY_TEILNEHMER_AM_LOSVERFAHREN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenTeilnehmerAmLosverfahren , teilnehmerAmLosverfahren));
    }
                            if (isSeitLadenVeraendertZaehler) {
      result.put(DHondtQuotientConstants.MESSAGE_KEY_ZAEHLER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenZaehler , zaehler));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                      isSeitLadenVeraendertNenner = false;
      wertNachLadenNenner = null;
                          isSeitLadenVeraendertRang = false;
      wertNachLadenRang = null;
                          isSeitLadenVeraendertSitzgewinn = false;
      wertNachLadenSitzgewinn = null;
                          isSeitLadenVeraendertTeilnehmerAmLosverfahren = false;
      wertNachLadenTeilnehmerAmLosverfahren = null;
                          isSeitLadenVeraendertZaehler = false;
      wertNachLadenZaehler = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "D_HONDT_QUOTIENT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "DHondtQuotient";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(DHondtQuotientConstants.DISCRIMINATOR_MAX_LENGTH ,  discriminator, this, DHondtQuotientConstants.MESSAGE_KEY_DISCRIMINATOR_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nenner, this, DHondtQuotientConstants.MESSAGE_KEY_NENNER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(DHondtQuotientConstants.NENNER_MAX_VALUE, DHondtQuotientConstants.NENNER_MIN_VALUE, nenner, this, DHondtQuotientConstants.MESSAGE_KEY_NENNER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(rang, this, DHondtQuotientConstants.MESSAGE_KEY_RANG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(DHondtQuotientConstants.RANG_MAX_VALUE, DHondtQuotientConstants.RANG_MIN_VALUE, rang, this, DHondtQuotientConstants.MESSAGE_KEY_RANG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(sitzgewinn, this, DHondtQuotientConstants.MESSAGE_KEY_SITZGEWINN_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(teilnehmerAmLosverfahren, this, DHondtQuotientConstants.MESSAGE_KEY_TEILNEHMER_AM_LOSVERFAHREN_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zaehler, this, DHondtQuotientConstants.MESSAGE_KEY_ZAEHLER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(DHondtQuotientConstants.ZAEHLER_MAX_VALUE, DHondtQuotientConstants.ZAEHLER_MIN_VALUE, zaehler, this, DHondtQuotientConstants.MESSAGE_KEY_ZAEHLER_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
